@Echo off
SETLOCAL EnableDelayedExpansion

If "%*"=="" ( Exit /B )

Set /A "__Alisha_DEBUG=0"
Call :__Zoey_Length_Entry __Alisha_

Set "__Alisha_Self_[Length]=!__Alisha_Length_[Length]!"
If !__Alisha_DEBUG! GTR 0 (
	Pause
)

Set "__Alisha_Project_ZPath_[Buffer]=%*"
Set "__Alisha_DevKit_ZPath_[Buffer]=%~dp0"

If !__Alisha_DEBUG! GTR 0 (
	Echo "A1::Project::ZPath" is "!__Alisha_Project_ZPath_[Buffer]!"
	Echo "A1::DevKit::ZPath" is "!__Alisha_DevKit_ZPath_[Buffer]!"
)

For /L %%A In ( 1, 1, 1 ) Do (
	Echo.
)

Echo === Welcome to !__Alisha_Project_ZPath_[Project]! ^(!__Alisha_Project_ZPath_[Version]!^) ===

	For /L %%A In ( 1, 1, 3 ) Do (
		Echo.
	)

Call :__Zoey_Focus_Entry Project
Call :__Zoey_Focus_Entry DevKit

Call :__Zoey_Flush_Vars_Entry ZPath

Set "__Alisha_Focus=DevKit"
Set "__Alisha_Environ_%__Alisha_Focus%=!__Alisha_%__Alisha_Focus%_ZPath_[Root]!!__Alisha_%__Alisha_Focus%_ZPath_[Project]! (!__Alisha_%__Alisha_Focus%_ZPath_[Version]!)\!__Alisha_%__Alisha_Focus%_ZPath_[Project]!"

Set "__Alisha_Focus=DevKit"
Set "__Alisha_Environ_%__Alisha_Focus%_Quick=!__Alisha_%__Alisha_Focus%_ZPath_[Root]!!__Alisha_%__Alisha_Focus%_ZPath_[Project]! (!__Alisha_%__Alisha_Focus%_ZPath_[Version]!)\"

Set "__Alisha_Focus=DevKit"

Set "__Alisha_Focus=Project"
Set "__Alisha_Environ_%__Alisha_Focus%=!__Alisha_%__Alisha_Focus%_ZPath_[Root]!!__Alisha_%__Alisha_Focus%_ZPath_[Project]! (!__Alisha_%__Alisha_Focus%_ZPath_[Version]!)\!__Alisha_%__Alisha_Focus%_ZPath_[Project]!"

Call :__Zoey_Version_Pretty_Entry DevKit

Set "__Alisha_Focus=Project"
Set "__Alisha_Environ_%__Alisha_Focus%=!__Alisha_%__Alisha_Focus%_ZPath_[Root]!!__Alisha_%__Alisha_Focus%_ZPath_[Project]! (!__Alisha_%__Alisha_Focus%_ZPath_[Version]!)\!__Alisha_%__Alisha_Focus%_ZPath_[Project]!"

Set "__Alisha_Focus=Project"
Set "__Alisha_Environ_%__Alisha_Focus%_Quick=!__Alisha_%__Alisha_Focus%_ZPath_[Root]!!__Alisha_%__Alisha_Focus%_ZPath_[Project]! (!__Alisha_%__Alisha_Focus%_ZPath_[Version]!)\"

Call :__Zoey_Version_Pretty_Entry Project

Set "__Alisha_Focus=DevKit"
Call "!__Alisha_Environ_%__Alisha_Focus%! Compile.cmd"

Exit /B 0

:__Zoey_Length_Entry
	Set /A "__Alisha_Length_[Length]=0"
	Set "__Alisha_Length_[Buffer]=%*"
	Call :__Zoey_Length_Loop
	If !__Alisha_DEBUG! GTR 0 (
		Echo "%*" is "!__Alisha_Length_[Length]!" in length.
		Pause
	)
	Exit /B
:__Zoey_Length_Loop
	Set "__Alisha_Length_[Char]=%__Alisha_Length_[Buffer]:~0,1%"
	If "!__Alisha_Length_[Buffer]!"=="" (
		Exit /B
	)
	Set "__Alisha_Length_[Buffer]=%__Alisha_Length_[Buffer]:~1%"
	If !__Alisha_DEBUG! GTR 0 (
		Echo !__Alisha_Length_[Length]! is "!__Alisha_Length_[Char]!"
	)
	Set /A "__Alisha_Length_[Length]+=1"
	Goto :__Zoey_Length_Loop

:__Zoey_Crawl_Entry
	
	Set /A "__Alisha_ZPath_[Count]=0"

	Call :__Zoey_ZPath_Entry %*
	Call :__Zoey_Root_Entry %*

	Call :__Zoey_Project_Entry !__Alisha_ZPath_[Count]!
	Call :__Zoey_Version_Entry !__Alisha_ZPath_[Count]!
	
	Exit /B
	
:__Zoey_ZPath_Entry

	Set "__Alisha_ZPath_[Buffer]=%*"
	
	If "!__Alisha_ZPath_[Count]!"=="" (
		Set /A "__Alisha_ZPath_[Count]=0"
	)

	If "!__Alisha_ZPath_[FolderCheck]!"=="" (
		Set /A "__Alisha_ZPath_[FolderCheck]=0"
	)
	
	Call :__Zoey_ZPath_Loop_1
	
	Exit /B
	
:__Zoey_ZPath_Loop_1

:__Zoey_ZPath_Loop_1b

	If "!__Alisha_ZPath_[Buffer]!"=="" (
		Exit /B
	)

	Set "__Alisha_ZPath_[Char]=!__Alisha_ZPath_[Buffer]:~0,1!"
	Set "__Alisha_ZPath_[Buffer]=!__Alisha_ZPath_[Buffer]:~1!"
	
	If "!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%][Length]!"=="" (
		Set /A "__Alisha_ZPath_[!__Alisha_ZPath_[Count]!][Length]=0"
	)
		
	If "!__Alisha_ZPath_[Buffer]!"=="" (
		If !__Alisha_DEBUG! GEQ 0 (
			Echo __Alisha_ZPath_[%__Alisha_ZPath_[Count]%] is ^"!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!^" ^( !__Alisha_ZPath_[%__Alisha_ZPath_[Count]%][Length]! ^)
		)
		Exit /B
	)
	
	Set /A "__Alisha_ZPath_[FolderCheck]=0"
	
	If "!__Alisha_ZPath_[Char]!"=="\" (
		Set /A "__Alisha_ZPath_[FolderCheck]+=1"
	) Else If "!__Alisha_ZPath_[Char]!"=="/" (
		Set /A "__Alisha_ZPath_[FolderCheck]+=1"
	)			
	
	If !__Alisha_ZPath_[FolderCheck]! GTR 0 (
		
		If !__Alisha_DEBUG! GEQ 0 (
			Echo __Alisha_ZPath_[%__Alisha_ZPath_[Count]%] is ^"!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!^" ^( !__Alisha_ZPath_[%__Alisha_ZPath_[Count]%][Length]! ^)
		)
		
		Set /A "__Alisha_ZPath_[Count]+=1"
		Set "__Alisha_ZPath_[!__Alisha_ZPath_[Count]!]="
		Set /A "__Alisha_ZPath_[!__Alisha_ZPath_[Count]!][Length]=0"
		
		Goto :__Zoey_ZPath_Loop_1b
		
	) Else (
		
		Set /A "__Alisha_ZPath_[!__Alisha_ZPath_[Count]!][Length]+=1"
		Set "__Alisha_ZPath_[!__Alisha_ZPath_[Count]!]=!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!!__Alisha_ZPath_[Char]!"
		
		Goto :__Zoey_ZPath_Loop_1b
		
	)

:__Zoey_Version_Entry
	
	If !__Alisha_DEBUG! GTR 0 (
		Echo Version :: Final Buffer :: !__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!
	)
	
	Set "__Alisha_ZPath_[Version]=!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!"
	
	Call :__Zoey_Version_Loop_1
	If !__Alisha_DEBUG! GTR 0 (
		Echo :__Zoey_Version_Entry :: "!__Alisha_ZPath_[Version]!"
		Pause
	)
	
	Call :__Zoey_Version_Pretty_Entry !__Alisha_ZPath_[Version]!

	Set "__Alisha_ZPath_[Version_Pretty]=!__Alisha_Version_[Pretty]!"
	
	Exit /B
	
:__Zoey_Version_Loop_1
	
	If "!__Alisha_ZPath_[Version]:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_ZPath_[Version]:~-1!"==")" (
		Set "__Alisha_ZPath_[Version]=!__Alisha_ZPath_[Version]:~0,-1!"
		Call :__Zoey_Version_Loop_2
		Exit /B
	) Else (
		Set "__Alisha_ZPath_[Version]=!__Alisha_ZPath_[Version]:~0,-1!"
		Goto :__Zoey_Version_Loop_1
	)
		
	Exit /B
	
:__Zoey_Version_Loop_2

:__Zoey_Version_Loop_2b
	
	If "!__Alisha_ZPath_[Version]:~0,1!"=="" (
		Exit /B
	)

	If "!__Alisha_ZPath_[Version]:~0,1!"=="(" (
		Set "__Alisha_ZPath_[Version]=!__Alisha_ZPath_[Version]:~1!"
		Exit /B
	) Else (
		Set "__Alisha_ZPath_[Version]=!__Alisha_ZPath_[Version]:~1!"
		Goto :__Zoey_Version_Loop_2b
	)

:__Zoey_Project_Entry
	
	If !__Alisha_DEBUG! GTR 0 (
		Echo Project :: Final Buffer :: !__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!
	)
	
	Set "__Alisha_ZPath_[Project]=!__Alisha_ZPath_[%__Alisha_ZPath_[Count]%]!"
	
	Call :__Zoey_Project_Loop_1
	If !__Alisha_DEBUG! GTR 0 (
		Echo :__Zoey_Project_Entry :: "!__Alisha_ZPath_[Project]!"
		Pause
	)
	Exit /B
	
:__Zoey_Project_Loop_1
	
	Goto :__Zoey_Project_Loop_1b
	
:__Zoey_Project_Loop_1b
	
	If "!__Alisha_ZPath_[Project]:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_ZPath_[Project]:~-1!"=="(" (
		Set "__Alisha_ZPath_[Project]=!__Alisha_ZPath_[Project]:~0,-1!"
		Call :__Zoey_Project_Loop_2
		Exit /B
	) Else (
		Set "__Alisha_ZPath_[Project]=!__Alisha_ZPath_[Project]:~0,-1!"
		Goto :__Zoey_Project_Loop_1b
	)

:__Zoey_Project_Loop_2
	
	Goto :__Zoey_Project_Loop_2b

:__Zoey_Project_Loop_2b

	If "!__Alisha_ZPath_[Project]:~-1!"=="" (
		Exit /B
	)

	If "!__Alisha_ZPath_[Project]:~-1!"==" " (
		Set "__Alisha_ZPath_[Project]=!__Alisha_ZPath_[Project]:~0,-1!"
		Goto :__Zoey_Project_Loop_2b
	) Else (
		Exit /B
	)

:__Zoey_Root_Entry

	Set "__Alisha_ZPath_[Root]="	
	Call :__Zoey_Root_Loop_1

	Exit /B

:__Zoey_Root_Loop_1
	
	Goto :__Zoey_Root_Loop_1b
	
:__Zoey_Root_Loop_1b

	For /L %%A In ( 0, 1, !__Alisha_ZPath_[Count]! ) Do (
		If %%A LSS !__Alisha_ZPath_[Count]! (
			Set "__Alisha_ZPath_[Root]=!__Alisha_ZPath_[Root]!!__Alisha_ZPath_[%%A]!\"
			If !__Alisha_DEBUG! GTR 0 (
				Echo __Alisha_ZPath_[Root] is ^"!__Alisha_ZPath_[Root]!^"
			)
		)
	)
	
	Exit /B
	
:__Zoey_Clone_Vars_Entry

	Call :__Zoey_Length_Entry %1
	Set /A "__Alisha_Clone_[Src_Length]=%__Alisha_Length_[Length]%"

	If !__Alisha_DEBUG! GTR 0 (
		Echo "%1" is %__Alisha_Clone_[Src_Length]% in Length.
	)
	
	Call :__Zoey_Length_Entry %2
	Set /A "__Alisha_Clone_[Dest_Length]=%__Alisha_Length_[Length]%"
	
	If !__Alisha_DEBUG! GTR 0 (
		Echo "%2" is %__Alisha_Clone_[Dest_Length]% in Length.
	)
	
	Call :__Zoey_Length_Entry __Alisha_
	
	Set /A "__Alisha_Src_Offset=!__Alisha_Length_[Length]!+!__Alisha_Clone_[Src_Length]!+1"
			
	Set /A "__Alisha_Dest_Offset=!__Alisha_Length_[Length]!+!__Alisha_Clone_[Dest_Length]!+!__Alisha_Clone_[Src_Length]!+2"
	
	For /F "usebackq tokens=*" %%G In ( `Set __Alisha_%1_` ) Do (
	
		Set __Alisha_Clone_[Buffer]=%%G
		Set __Alisha_Clone_[Suffix]=!__Alisha_Clone_[Buffer]:~%__Alisha_Src_Offset%!
			
		Set __Alisha_Clone_[Prefix]=__Alisha_%2_
		Set __Alisha_Clone_[Temp]=!__Alisha_Clone_[Prefix]!%1_!__Alisha_Clone_[Suffix]!
	
		If !__Alisha_DEBUG! GTR 0 (
			Echo Clone	:: "!__Alisha_Clone_[Temp]!"
		)

		Call Set "!__Alisha_Clone_[Temp]!"
	)

	Exit /B
	
	
:__Zoey_Flush_Vars_Entry
	
	For /F "usebackq" %%G In ( `Set __Alisha_%*_` ) Do (
		Call :__Zoey_Flush_Vars_Loop_1 %%G
		If !__Alisha_DEBUG! GTR 0 (
			Echo Flushing: !__Alisha_Temp_Flush_Label! ^( "!__Alisha_Temp_Flush_Value!" ^)
		)

		Call Set "!__Alisha_Temp_Flush_Instruction!"
	)
	
	Exit /B

:__Zoey_Flush_Vars_Loop_1

	Set "__Alisha_Temp_Flush_Buffer=%*"
	Set "__Alisha_Temp_Flush_Label="
	Set "__Alisha_Temp_Flush_Value="
	Goto :__Zoey_Flush_Vars_Loop_1b

:__Zoey_Flush_Vars_Loop_1b

	If "!__Alisha_Temp_Flush_Buffer:~0,1!"=="=" (
		Set "__Alisha_Temp_Flush_Value=!__Alisha_Temp_Flush_Buffer:~1!"
		Set "__Alisha_Temp_Flush_Instruction=!__Alisha_Temp_Flush_Label!="
		Exit /B
	) Else (
		Set "__Alisha_Temp_Flush_Label=!__Alisha_Temp_Flush_Label!!__Alisha_Temp_Flush_Buffer:~0,1!"
		Set "__Alisha_Temp_Flush_Buffer=!__Alisha_Temp_Flush_Buffer:~1!"
		Goto :__Zoey_Flush_Vars_Loop_1b
	)
	
:__Zoey_Focus_Entry

	Set "__Alisha_Focus=%*"

	For /L %%A In ( 1, 1, 1 ) Do (
		Echo.
	)
	
	Echo === Focus :: %__Alisha_Focus% ===
	
	For /L %%A In ( 1, 1, 3 ) Do (
		Echo.
	)

	Call :__Zoey_Flush_Vars_Entry ZPath
	Set "__Alisha_ZPath_[Buffer]=!__Alisha_%__Alisha_Focus%_ZPath_[Buffer]!"
	Call :__Zoey_Flush_Vars_Entry %__Alisha_Focus%
	Set "__Alisha_%__Alisha_Focus%_ZPath_[Buffer]=!__Alisha_ZPath_[Buffer]!"
	Call :__Zoey_Crawl_Entry !__Alisha_%__Alisha_Focus%_ZPath_[Buffer]!
	
	Call :__Zoey_Project_Entry
	Call :__Zoey_Version_Entry
	Call :__Zoey_Root_Entry
	Call :__Zoey_Version_Pretty_Entry

	Call :__Zoey_Clone_Vars_Entry ZPath %__Alisha_Focus%
	
	Echo Project :: "!__Alisha_%__Alisha_Focus%_ZPath_[Project]!"
	Echo Version :: "!__Alisha_%__Alisha_Focus%_ZPath_[Version]!"
	Echo Root    :: "!__Alisha_%__Alisha_Focus%_ZPath_[Root]!"
	Echo Pretty  :: "!__Alisha_%__Alisha_Focus%_ZPath_[Version][Pretty]!"

	Call :__Zoey_Flush_Vars_Entry ZPath	

	For /L %%A In ( 1, 1, 3 ) Do (
		Echo.
	)
	Pause

	Exit /B

:__Zoey_Version_Pretty_Entry
		
	If !__Alisha_DEBUG! GTR 0 (
		Echo === Pretty :: Version ===
	)
	Set "__Alisha_ZPath_[Version][Buffer]=!__Alisha_ZPath_[Version]!"
	
	If !__Alisha_DEBUG! GTR 0 (
		Echo __Alisha_ZPath_[Version][Buffer] --^> "!__Alisha_ZPath_[Version][Buffer]!" ^<--
	)

	Set "__Alisha_ZPath_[Version][Pretty]="
	
	Call :__Zoey_Version_Pretty_Loop
	
	Exit /B

:__Zoey_Version_Pretty_Loop
	
	Goto :__Zoey_Version_Pretty_Loop_2
	
:__Zoey_Version_Pretty_Loop_2
	
	If "!__Alisha_ZPath_[Version][Buffer]!"=="" (
		Exit /B
	)
	
	If !__Alisha_DEBUG! GTR 0 (
		Echo [Char  ] :: "!__Alisha_ZPath_[Version][Char]!"
	`	Echo [Buffer] :: "!__Alisha_ZPath_[Version][Buffer]!"
		Echo [Pretty] :: "!__Alisha_ZPath_[Version][Pretty]!"
	)

	Set "__Alisha_ZPath_[Version][Char]=!__Alisha_ZPath_[Version][Buffer]:~0,1!"
	Set "__Alisha_ZPath_[Version][Buffer]=!__Alisha_ZPath_[Version][Buffer]:~1!"

	If "!__Alisha_ZPath_[Version][Char]!"=="" (
		Exit /B
	)

	If "!__Alisha_ZPath_[Version][Char]!"=="-" (
		Set "__Alisha_ZPath_[Version][Char]=."
	)
	
	Set "__Alisha_ZPath_[Version][Pretty]=!__Alisha_ZPath_[Version][Pretty]!!__Alisha_ZPath_[Version][Char]!"
	
	Goto :__Zoey_Version_Pretty_Loop_2
