@Echo off
SETLOCAL EnableDelayedExpansion

For /L %%A In ( 1, 1, 1 ) Do (
	Echo.
)

Echo === Welcome to !__Alisha_DevKit_ZPath_[Project]! Compile.cmd ===

For /L %%A In ( 1, 1, 3 ) Do (
	Echo.
)

Pause

Call :__Zoey_Capture_Entry

Pause

Call :__Zoey_Dir_Entry

Pause

Call :__Zoey_Version_Entry

Pause

Echo ^(Main^)

Pause

If Exist "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]!.seq" (
	Echo Found: "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]!.seq"

	For /F "usebackq tokens=* delims=" %%X In ( "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]!.seq" ) Do ( 
		Set "__Alisha_Seq=%%~X"
		
		Set /A "__Alisha_Skip=1"

		If "!__Alisha_Seq:~0,9!"=="__Alisha_" (
			Set /A "__Alisha_Skip=0"
		)
		
		If "!__Alisha_Seq:~0,10!!__Alisha_Seq:~-1!"==""__Alisha_"" (
			Set /A "__Alisha_Skip=0"
		)
		
		If !__Alisha_Skip! GTR 0 (
			Echo Skipped: "!__Alisha_Seq!"
			Rem Pause
		) Else (
			Call Set "!__Alisha_Seq!"
		)	
	)
	
Rem Pause
	
) Else (
	
	Echo Missing: "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]!.seq"
	
Rem Pause
	Exit /B
)

@Echo on

If Exist "!__Alisha_options_source!" ( 
	Echo Found: "!__Alisha_options_source!" ^(__Alisha_options_source^)
	
	Pause

) Else (
	Echo Missing: "!__Alisha_options_source!" ^(__Alisha_options_source^)
	Pause
	Exit /B
)

Call :__Zoey_Dump_Seq_Entry

Call :__Zoey_PassThru_Entry

Call :__Zoey_VarMap_Entry

Call "!__Alisha_Environ_DevKit_Quick!Capture.cmd"

Exit /B 0


:__Zoey_Capture_Entry

	Set "__Alisha_Temp=%~nx0"
	
	Set "__Alisha_Extension="
	
:__Zoey_Capture_Extension_Loop
	
	Rem Echo Extension: "%__Alisha_Extension%"

Rem Pause
	
	If Not "%__Alisha_Temp:~-1%"=="." (
		Set "__Alisha_Extension=%__Alisha_Temp:~-1%%__Alisha_Extension%"
		Set "__Alisha_Temp=%__Alisha_Temp:~0,-1%"
		Goto :__Zoey_Capture_Extension_Loop
	) Else (	
		Set "__Alisha_Extension=%__Alisha_Temp:~-1%%__Alisha_Extension%"
		Set "__Alisha_Temp=%__Alisha_Temp:~0,-1%"
	)

	Set "__Alisha_Method="
	
:__Zoey_Capture_Method_Loop

	Rem Echo Extension: "%__Alisha_Extension%"
	Rem Echo Method: "%__Alisha_Method%"

Rem Pause
	
	If Not "%__Alisha_Temp:~-1%"==" " (
		Set "__Alisha_Method=%__Alisha_Temp:~-1%%__Alisha_Method%"
		Set "__Alisha_Temp=%__Alisha_Temp:~0,-1%"
		Goto :__Zoey_Capture_Method_Loop
	) Else (	
		Set "__Alisha_Temp=%__Alisha_Temp:~0,-1%"
	)
	
	Set "__Alisha_Project="
	
:__Zoey_Capture_Project_Loop

	Set "__Alisha_Project=%__Alisha_Temp%"
	Set "__Alisha_Temp="
	
	Rem Echo Extension: "%__Alisha_Extension%"
	Rem Echo Method: "%__Alisha_Method%"
	Rem Echo Project: "%__Alisha_Project%"
	
Rem Pause
	
	Exit /B

:__Zoey_Dir_Entry

	Set "__Alisha_Current_Dir=!cd!"
	ChDir ".."
	Set "__Alisha_Parent_Dir=!cd!"
	ChDir "!__Alisha_Current_Dir!"
	
	Echo Current_Dir: %__Alisha_Current_Dir%
	Echo Parent_Dir: %__Alisha_Parent_Dir%
	
	Set /A "__Alisha_Dir_Length=0"
	
	Goto :__Zoey_Dir_Loop
	
:__Zoey_Dir_Loop
	
	Rem Echo Local_Dir: %__Alisha_Local_Dir%
	Rem Echo Dir Length: %__Alisha_Dir_Length%
	
Rem Pause
	
	If Not "!__Alisha_Parent_Dir:~%__Alisha_Dir_Length%,1!"=="" (
		Set /A "__Alisha_Dir_Length+=1"
		Goto :__Zoey_Dir_Loop
	)
	
	Set /A "__Alisha_Dir_Length+=1"
	
	Set "__Alisha_Local_Dir=!__Alisha_Current_Dir:~%__Alisha_Dir_Length%!"

	Echo Local_Dir: %__Alisha_Local_Dir%
	Echo Dir Length: %__Alisha_Dir_Length%
	
Rem Pause
	
	Exit /B

:__Zoey_Dump_Seq_Entry

	For /L %%A In ( 1, 1, 1 ) Do (
		Echo.
	)

	Echo === Seq Dump: "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]! Config Dump.seq" ===
	

	For /L %%A In ( 1, 1, 3 ) Do (
		Echo.
	)

	Pause

	If Exist "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]! Config Dump.seq" (
		Del /F "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]! Config Dump.seq"
	)
	
	(
		
		For /F "usebackq tokens=* delims=" %%X In ( `Set __Alisha_` ) Do (
			Echo %%X
		)
	
	) >> "!__Alisha_Environ_DevKit_Quick!settings\!__Alisha_Project_ZPath_[Project]! Config Dump.seq"
	
	Exit /B

:__Zoey_PassThru_Entry

	
	Echo Project: "!__Alisha_Project_ZPath_[Project]!"
	Echo version: "!__Alisha_version!"
		
Rem Pause
	
	For %%A In ( !__Alisha_PassThru_Queue! ) Do (

		Set __Alisha_Prefix=%%~nA
		Set __Alisha_Suffix=%%~xA
		
		Echo PassThru Output: "!__Alisha_Environ_Project_Quick!!__Alisha_Project_ZPath_[Project]! !__Alisha_Prefix!!__Alisha_Suffix!"

Rem Pause

		Set /A "__Alisha_Exist_Count=0"
		
		If Exist "!__Alisha_Environ_DevKit_Quick!!__Alisha_DevKit_ZPath_[Project]! !__Alisha_Prefix!.cmd" (
			
			Echo Detected PassThru ^(!__Alisha_DevKit_ZPath_[Project]!^): "!__Alisha_Environ_DevKit_Quick!!__Alisha_DevKit_ZPath_[Project]! !__Alisha_Prefix!.cmd"
			
Rem Pause
	
			Set /A "__Alisha_Exist_Count+=1"
			
		)
				
		If Exist "!__Alisha_Environ_Project_Quick!!__Alisha_Project_ZPath_[Project]! !__Alisha_Prefix!!__Alisha_Suffix!" (
			
			Echo Pruning: "!__Alisha_Environ_Project_Quick!!__Alisha_Project_ZPath_[Project]! !__Alisha_Prefix!!__Alisha_Suffix!"

Rem Pause

			Del /F "!__Alisha_Environ_Project_Quick!!__Alisha_Project_ZPath_[Project]! !__Alisha_Prefix!!__Alisha_Suffix!"
		)
		
		If !__Alisha_Exist_Count! EQU 1 (
						
			Echo Calling: "!__Alisha_Environ_DevKit_Quick!!__Alisha_DevKit_ZPath_[Project]! !__Alisha_Prefix!.cmd"		
			
Rem Pause

			Call "!__Alisha_Environ_DevKit_Quick!!__Alisha_DevKit_ZPath_[Project]! !__Alisha_Prefix!.cmd"		

		)

	)
	
	Exit /B

:__Zoey_Version_Entry

	Set "__Alisha_version="
	Set "__Alisha_version_Temp=!__Alisha_Local_Dir!"
	Set "__Alisha_version_gate=locked"
	
	:__Zoey_version_Loop_1
		
		Set "__Alisha_version_Char=!__Alisha_version_Temp:~0,1!"
		Set "__Alisha_version_Temp=!__Alisha_version_Temp:~1!"
		
		If "!__Alisha_version_Char!"=="" (
			Set "__Alisha_version_gate=closed"
			Goto :__Zoey_version_Loop_2
		)
	
		If "!__Alisha_version_Char!"=="(" (
			Set "__Alisha_version_gate=open"
			Goto :__Zoey_version_Loop_1
		)
			
		If "!__Alisha_version_Char!"==")" (
			Set "__Alisha_version_gate=closed"
			Goto :__Zoey_version_Loop_2
		)
			
		If "!__Alisha_version_gate!"=="open" (
			Set "__Alisha_version=!__Alisha_version!!__Alisha_version_Char!"
		)
		
		If "!__Alisha_version_gate!"=="closed" (
			Goto :__Zoey_version_Loop_2
		)
		
		Goto :__Zoey_version_Loop_1

	:__Zoey_version_Loop_2

	Set "__Alisha_version_verbose=!__Alisha_version!"
	Set "__Alisha_version_pretty=!__Alisha_version:-=.!"

	Echo version ^(raw^): "%__Alisha_version%"
	Echo version ^(verbose^): "%__Alisha_version%"
	Echo version ^(pretty^): "%__Alisha_version_pretty%"

	Echo Project: "%__Alisha_Project%"
	
Rem Pause
	
	Exit /B

:__Zoey_StrLen_Entry

	Set "__Alisha_StrLen_Haystack=%*"
	Set /A "__Alisha_StrLen_Length=0"
	
	Call :__Zoey_StrLen_Loop %*
	
	Exit /B
	
:__Zoey_StrLen_Loop

	If Not "!__Alisha_StrLen_Haystack:~%__Alisha_StrLen_Length%!"=="" (
		Set /A "__Alisha_StrLen_Length+=1"
		Goto :__Zoey_StrLen_Loop
	)
	
	Exit /B
	
:__Zoey_Token[Count]_Entry

	Exit /B

:__Zoey_Token[Count]_Construct

	Set "__Alisha_Token[Needle]=!%*:~0,1!	
	Set "__Alisha_Token[Haystack]=!%*:~1!
	
	Set /A "__Alisha_Token[Count]=0"
	Exit /B
		
:__Zoey_Token[Count]_Loop
	
	If "!__Alisha_Token[Haystack]:~1!"=="" ( Exit /B )

	If "!__Alisha_Token[Haystack]:~1,1!"=="!__Alisha_Token[Needle]!" (
		Set /A "__Alisha_Token[Count]+=1"
		Set /A "__Alisha_Token[Haystack]=!__Alisha_Token[Haystack]:~2!"
		Goto :__Zoey_Token[Count]_Loop
	)
	
	Set /A "__Alisha_Token[!__Alisha_Token[Count]!]=!__Alisha_Token[%__Alisha_Token[Count]%]!!__Alisha_Token[Haystack]:~0,1!"
	
	Set /A "__Alisha_Token[Haystack]=!__Alisha_Token[Haystack]:~1!"
	Goto :__Zoey_Token[Count]_Loop

:__Zoey_Advanced_Token[Range]_Entry
	
	Exit /B

:__Zoey_Advanced_Token[Range]_Construct

	Exit /B
	
:__Zoey_Advanced_Token[Range]_Loop
	
	For %%d In (%1, 1, %2 ) Do (
		
		Set "__Alisha_Advanced_Token[Temp]=!__Alisha_Token[%%d]!"
		Set "__Alisha_Advanced_Token[Temp]=!__Alisha_Token[%__Alisha_Advanced_Token[Temp]%]!"
		Set /A "__Alisha_Advanced_Token[%1-%2]=!__Alisha_Advanced_Token[%1-%2]!!__Alisha_Advanced_Token[Temp]!"
		:: Goto :__Zoey_Advanced_Token[Range]_Loop
	)
	
	Exit /B
	
:__Zoey_Advanced_Token_2[Range]_Entry
	

	Exit /B

:__Zoey_Advanced_Token_2[Range]_Construct

	Exit /B
		
:__Zoey_Advanced_Token_2[Range]_Loop
	
	For %%d In (%1, 1, %2 ) Do (
		
		Set "__Alisha_Advanced_Token_2[Temp]=!__Alisha_Token[%%d]!"
		Set "__Alisha_Advanced_Token_2[Temp]=!__Alisha_Token[%__Alisha_Advanced_Token_2[Temp]%]!"
		Set /A "__Alisha_Advanced_Token_2[%1-%2]=!__Alisha_Advanced_Token_2[%1-%2]!!__Alisha_Advanced_Token_2[Temp]!"
		:: Goto :__Zoey_Advanced_Token_2[Range]_Loop
	)
	
	Exit /B
